'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.onFormSelectStateChanged = exports.onFormSelectOptionSelected = exports.onFormSelectInitialized = exports.onGMapGeocodeNoResults = exports.onGMapMarkerSelected = exports.onGMapInitialized = undefined;

var _lin3sEventBus = require('lin3s-event-bus');

var _GMapInitializedEventSubscriber = require('./GMap/GMapInitializedEventSubscriber');

var _GMapInitializedEventSubscriber2 = _interopRequireDefault(_GMapInitializedEventSubscriber);

var _GMapMarkerSelectedEventSubscriber = require('./GMap/GMapMarkerSelectedEventSubscriber');

var _GMapMarkerSelectedEventSubscriber2 = _interopRequireDefault(_GMapMarkerSelectedEventSubscriber);

var _GMapGeocodeNoResultsEventSubscriber = require('./GMap/GMapGeocodeNoResultsEventSubscriber');

var _GMapGeocodeNoResultsEventSubscriber2 = _interopRequireDefault(_GMapGeocodeNoResultsEventSubscriber);

var _FormSelectInitializedEventSubscriber = require('./FormSelect/FormSelectInitializedEventSubscriber');

var _FormSelectInitializedEventSubscriber2 = _interopRequireDefault(_FormSelectInitializedEventSubscriber);

var _FormSelectOptionSelectedEventSubscriber = require('./FormSelect/FormSelectOptionSelectedEventSubscriber');

var _FormSelectOptionSelectedEventSubscriber2 = _interopRequireDefault(_FormSelectOptionSelectedEventSubscriber);

var _FormSelectStateChangedEventSubscriber = require('./FormSelect/FormSelectStateChangedEventSubscriber');

var _FormSelectStateChangedEventSubscriber2 = _interopRequireDefault(_FormSelectStateChangedEventSubscriber);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * This file is part of the Front Foundation package.
 *
 * Copyright (c) 2017-present LIN3S <info@lin3s.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 *
 * @author Mikel Tuesta <mikeltuesta@gmail.com>
 */

var onGMapInitialized = function onGMapInitialized(domNode, onGMapInitializedCallback, priority) {
  var gmapInitializedEventSubscriber = new _GMapInitializedEventSubscriber2.default(domNode, onGMapInitializedCallback, new _lin3sEventBus.Priority(priority));

  _lin3sEventBus.EventPublisher.subscribe(gmapInitializedEventSubscriber);

  return gmapInitializedEventSubscriber;
},
    onGMapMarkerSelected = function onGMapMarkerSelected(domNode, onGMapMarkerSelectedCallback, priority) {
  var gmapMarkerSelectedEventSubscriber = new _GMapMarkerSelectedEventSubscriber2.default(domNode, onGMapMarkerSelectedCallback, new _lin3sEventBus.Priority(priority));

  _lin3sEventBus.EventPublisher.subscribe(gmapMarkerSelectedEventSubscriber);

  return gmapMarkerSelectedEventSubscriber;
},
    onGMapGeocodeNoResults = function onGMapGeocodeNoResults(domNode, onGMapGeocodeNoResultsCallback, priority) {
  var gmapGeocodeNoResultsEventSubscriber = new _GMapGeocodeNoResultsEventSubscriber2.default(domNode, onGMapGeocodeNoResultsCallback, new _lin3sEventBus.Priority(priority));

  _lin3sEventBus.EventPublisher.subscribe(gmapGeocodeNoResultsEventSubscriber);

  return gmapGeocodeNoResultsEventSubscriber;
};

var onFormSelectInitialized = function onFormSelectInitialized(domNode, onFormSelectInitializedCallback, priority) {
  var formSelectInitializedEventSubscriber = new _FormSelectInitializedEventSubscriber2.default(domNode, onFormSelectInitializedCallback, new _lin3sEventBus.Priority(priority));

  _lin3sEventBus.EventPublisher.subscribe(formSelectInitializedEventSubscriber);

  return formSelectInitializedEventSubscriber;
},
    onFormSelectOptionSelected = function onFormSelectOptionSelected(domNode, onFormSelectOptionSelectedCallback, priority) {
  var formSelectOptionSelectedEventSubscriber = new _FormSelectOptionSelectedEventSubscriber2.default(domNode, onFormSelectOptionSelectedCallback, new _lin3sEventBus.Priority(priority));

  _lin3sEventBus.EventPublisher.subscribe(formSelectOptionSelectedEventSubscriber);

  return formSelectOptionSelectedEventSubscriber;
},
    onFormSelectStateChanged = function onFormSelectStateChanged(domNode, onFormSelectStateChangedCallback, priority) {
  var formSelectStateChangedEventSubscriber = new _FormSelectStateChangedEventSubscriber2.default(domNode, onFormSelectStateChangedCallback, new _lin3sEventBus.Priority(priority));

  _lin3sEventBus.EventPublisher.subscribe(formSelectStateChangedEventSubscriber);

  return formSelectStateChangedEventSubscriber;
};

exports.onGMapInitialized = onGMapInitialized;
exports.onGMapMarkerSelected = onGMapMarkerSelected;
exports.onGMapGeocodeNoResults = onGMapGeocodeNoResults;
exports.onFormSelectInitialized = onFormSelectInitialized;
exports.onFormSelectOptionSelected = onFormSelectOptionSelected;
exports.onFormSelectStateChanged = onFormSelectStateChanged;