'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getHtmlLang = require('./../dom/getHtmlLang');

var _getHtmlLang2 = _interopRequireDefault(_getHtmlLang);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 *  In order to include the needed Parsley.js locale modules during compilation time, and prevent a ReferenceError
 *  during execution time, we must include the locales this way. By wrapping the require function with a conditional,
 *  we ensure that this error is not thrown and breaks the execution process.
 *
 *  We will provide the required locales by setting an env parameter in our project's package.json file.
 *
 *  More info: https://webpack.js.org/plugins/context-replacement-plugin/
 */
/* eslint-disable no-undef */
if (typeof WEBPACK_ENV_LOCALE !== 'undefined') {
  require('parsleyjs/dist/i18n/' + WEBPACK_ENV_LOCALE + '.js');
}
/* eslint-enable no-undef */

/*
 * This file is part of the Front Foundation package.
 *
 * Copyright (c) 2017-present LIN3S <info@lin3s.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 *
 * @author Beñat Espiña <benatespina@gmail.com>
 */

var getLang = function getLang(lang) {
  if (null !== lang) {
    return lang;
  }

  return (0, _getHtmlLang2.default)();
};

exports.default = function () {
  var lang = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;

  var dividedLang = getLang(lang).split('_');

  var locale = lang;
  if (dividedLang.length > 0) {
    locale = dividedLang[0];
  }

  window.Parsley.setLocale(locale);
};