'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ArrowDown = require('./../../svg/ArrowDown');

var _ArrowDown2 = _interopRequireDefault(_ArrowDown);

var _Loader = require('./../Loader/Loader');

var _Loader2 = _interopRequireDefault(_Loader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * This file is part of the Euskaltel project.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright (c) 2017 LIN3S <info@lin3s.com>
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * For the full copyright and license information, please view the LICENSE
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * file that was distributed with this source code.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author Mikel Tuesta <mikel@lin3s.com>
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

var isMobile = function isMobile(viewportWidth) {
  return viewportWidth < 1024;
};

var FormSelect = function (_React$Component) {
  _inherits(FormSelect, _React$Component);

  function FormSelect(props) {
    _classCallCheck(this, FormSelect);

    var _this = _possibleConstructorReturn(this, (FormSelect.__proto__ || Object.getPrototypeOf(FormSelect)).call(this, props));

    _this.optionNodesRefs = [];

    _this.state = {
      dataRendered: true,
      editingInput: false,
      opened: false,
      selectedOption: props.options[0],
      hoveredOption: null
    };

    // bre-bind method's context
    _this.onClick = _this.onClick.bind(_this);
    _this.onOutsideClick = _this.onOutsideClick.bind(_this);
    _this.onLabelClick = _this.onLabelClick.bind(_this);
    _this.onInputChange = _this.onInputChange.bind(_this);
    _this.onKeyDown = _this.onKeyDown.bind(_this);
    return _this;
  }

  _createClass(FormSelect, [{
    key: 'onInputChange',
    value: function onInputChange(event) {
      event.persist();
      this.props.onInputChanged(event.target.value);
    }
  }, {
    key: 'onClick',
    value: function onClick(event) {
      if (!this.props.outsideClickToCloseEnabled) {
        return;
      }

      event.persist();
      event.stopPropagation();
    }
  }, {
    key: 'onLabelClick',
    value: function onLabelClick() {
      if (this.state.opened) {
        this.closeSelect();
      } else {
        this.openSelect();
      }
    }
  }, {
    key: 'onOutsideClick',
    value: function onOutsideClick() {
      this.closeSelect();
    }
  }, {
    key: 'onKeyDown',
    value: function onKeyDown(event) {
      var keyCode = event.which;

      if (!this.state.opened || !(keyCode === 40 || keyCode === 38 || keyCode === 13)) {
        return;
      }

      var hoveredOption = this.state.hoveredOption;
      var options = this.props.options;


      var hoveredOptionIndex = options.indexOf(hoveredOption);

      if (keyCode === 40) {
        // down
        hoveredOptionIndex = hoveredOptionIndex < 0 ? 0 : hoveredOptionIndex + 1 >= options.length ? options.length - 1 : hoveredOptionIndex + 1;

        this.setState({
          hoveredOption: options[hoveredOptionIndex]
        });

        this.optionNodesRefs[hoveredOptionIndex].scrollIntoView({ behaviour: 'smooth' });
      } else if (keyCode === 38) {
        // up
        hoveredOptionIndex = hoveredOptionIndex < 0 ? 0 : hoveredOptionIndex - 1 < 0 ? 0 : hoveredOptionIndex - 1;

        this.setState({
          hoveredOption: options[hoveredOptionIndex]
        });

        this.optionNodesRefs[hoveredOptionIndex].scrollIntoView({ behaviour: 'smooth' });
      } else if (keyCode === 13) {
        // enter
        this.onOptionSelected(hoveredOption);
      }
    }
  }, {
    key: 'onOptionSelected',
    value: function onOptionSelected(option) {
      if (!this.props.enabled) {
        return;
      }

      this.setState({
        selectedOption: option
      });

      this.props.onOptionSelected(option);

      this.closeSelect();
    }
  }, {
    key: 'onOptionMouseOver',
    value: function onOptionMouseOver(option) {
      if (!this.props.enabled) {
        return;
      }

      this.setState({
        hoveredOption: option
      });
    }
  }, {
    key: 'openSelect',
    value: function openSelect() {
      if (!this.props.enabled) {
        return;
      }

      if (this.props.filterable) {
        this.filterInput.focus();
      }

      this.setState({
        opened: true,
        editingInput: this.props.filterable
      });
    }
  }, {
    key: 'closeSelect',
    value: function closeSelect() {
      if (this.props.filterable) {
        this.filterInput.blur();
      }

      this.setState({
        editingInput: false,
        opened: false
      });
    }
  }, {
    key: 'getOptionsContainerHeight',
    value: function getOptionsContainerHeight() {
      var windowWidth = this.props.windowWidth;


      var totalHeight = this.optionNodesRefs.reduce(function (accumulatedHeight, optionNodeRef) {
        return accumulatedHeight + (optionNodeRef !== null ? optionNodeRef.getBoundingClientRect().height : 0);
      }, 0);

      if (isMobile(windowWidth) && totalHeight > FormSelect.OPTIONS_CONTAINER_MAX_HEIGHT_MOBILE) {
        return FormSelect.OPTIONS_CONTAINER_MAX_HEIGHT_MOBILE;
      } else if (!isMobile(windowWidth) && totalHeight > FormSelect.OPTIONS_CONTAINER_MAX_HEIGHT_DESKTOP) {
        return FormSelect.OPTIONS_CONTAINER_MAX_HEIGHT_DESKTOP;
      }

      return totalHeight;
    }
  }, {
    key: 'getOptionsContainerNeedsOverflow',
    value: function getOptionsContainerNeedsOverflow(optionsContainerHeight) {
      var windowWidth = this.props.windowWidth;


      return isMobile(windowWidth) && optionsContainerHeight >= FormSelect.OPTIONS_CONTAINER_MAX_HEIGHT_MOBILE || !isMobile(windowWidth) && optionsContainerHeight >= FormSelect.OPTIONS_CONTAINER_MAX_HEIGHT_DESKTOP;
    }
  }, {
    key: 'getDangerousHtml',
    value: function getDangerousHtml(rawHtml) {
      return { __html: rawHtml };
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.setState(function (prevState) {
        return {
          dataRendered: false,
          editingInput: nextProps.enabled && prevState.editingInput,
          opened: nextProps.enabled && prevState.opened,
          selectedOption: nextProps.enabled ? prevState.selectedOption : nextProps.options[0],
          hoveredOption: null
        };
      });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.outsideClickToCloseEnabled) {
        window.addEventListener('click', this.onOutsideClick);
      }

      /* eslint-disable react/no-did-mount-set-state */
      this.setState({
        dataRendered: false
      });
      /* eslint-enable react/no-did-mount-set-state */
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      window.removeEventListener('click', this.onOutsideClick);
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (this.props.options !== prevProps.options) {
        /* eslint-disable react/no-did-update-set-state */
        this.setState({
          dataRendered: false
        });
        /* eslint-enable react/no-did-update-set-state */
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      /* eslint-disable react/no-danger */

      var _state = this.state,
          dataRendered = _state.dataRendered,
          editingInput = _state.editingInput,
          opened = _state.opened,
          selectedOption = _state.selectedOption,
          hoveredOption = _state.hoveredOption;
      var _props = this.props,
          enabled = _props.enabled,
          filterable = _props.filterable,
          filterValue = _props.filterValue,
          id = _props.id,
          label = _props.label,
          loading = _props.loading,
          options = _props.options,
          required = _props.required;

      var formSelectClassName = 'form-select\n        ' + (opened && enabled ? ' form-select--opened' : '') + '\n        ' + (loading ? ' form-select--loading' : '') + '\n        ' + (!enabled ? ' form-select--disabled' : '') + '\n        ' + (filterable && editingInput ? ' form-select--editing-input' : ''),
          selectLabel = selectedOption !== undefined && selectedOption !== null ? this.getDangerousHtml(selectedOption.label) : this.getDangerousHtml(options[0].label),
          optionsContainerHeight = opened && !dataRendered ? this.getOptionsContainerHeight() : 0,
          needsOverflow = this.getOptionsContainerNeedsOverflow(optionsContainerHeight),
          optionsContainerClassName = 'form-select__options-container' + (!needsOverflow ? ' form-select__options-container--no-overflow' : '');

      return _react2.default.createElement(
        'div',
        { className: formSelectClassName,
          onClick: this.onClick,
          onKeyDown: this.onKeyDown },
        filterable && _react2.default.createElement('input', { className: 'form-select__select',
          id: id,
          name: id,
          required: required,
          type: 'hidden',
          value: selectedOption !== undefined && selectedOption !== null ? selectedOption.value : '' }),
        _react2.default.createElement(
          'div',
          { className: 'form-select__loader' },
          _react2.default.createElement(_Loader2.default, null)
        ),
        _react2.default.createElement(
          'span',
          { className: 'form-select__dropdown-icon' },
          _react2.default.createElement(_ArrowDown2.default, null)
        ),
        filterable && _react2.default.createElement(
          'div',
          { className: 'form-select__input-container' },
          _react2.default.createElement('input', { className: 'form-input form-select__input',
            onChange: this.onInputChange,
            placeholder: label,
            ref: function ref(input) {
              _this2.filterInput = input;
            },
            type: 'text', value: filterValue })
        ),
        _react2.default.createElement('div', { className: 'form-select__label',
          dangerouslySetInnerHTML: selectLabel,
          onClick: this.onLabelClick }),
        _react2.default.createElement(
          'div',
          { className: optionsContainerClassName, style: { height: optionsContainerHeight } },
          _react2.default.createElement(
            'div',
            { className: 'form-select__options' },
            options && options.map(function (option, index) {
              var formOptionClassName = 'form-select__option' + (option === selectedOption ? ' form-select__option--active' : '') + (option === hoveredOption ? ' form-select__option--hover' : ''),
                  labelHtml = _this2.getDangerousHtml(option.label);
              return _react2.default.createElement('div', { className: formOptionClassName,
                dangerouslySetInnerHTML: labelHtml,
                key: 'form-select-view-' + index,
                onClick: _this2.onOptionSelected.bind(_this2, option),
                onMouseOver: _this2.onOptionMouseOver.bind(_this2, option),
                ref: function ref(optionNode) {
                  _this2.optionNodesRefs[index] = optionNode;
                } });
            })
          )
        )
      );
      /* eslint-enable react/no-danger */
    }
  }]);

  return FormSelect;
}(_react2.default.Component);

FormSelect.OPTIONS_CONTAINER_MAX_HEIGHT_MOBILE = 260;
FormSelect.OPTIONS_CONTAINER_MAX_HEIGHT_DESKTOP = 275;
FormSelect.propTypes = {
  enabled: _propTypes2.default.bool,
  filterValue: _propTypes2.default.string,
  filterable: _propTypes2.default.bool,
  id: _propTypes2.default.string.isRequired,
  label: _propTypes2.default.string.isRequired,
  loading: _propTypes2.default.bool,
  onInputChanged: _propTypes2.default.func,
  onOptionSelected: _propTypes2.default.func.isRequired,
  options: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    label: _propTypes2.default.string,
    value: _propTypes2.default.string
  })),
  outsideClickToCloseEnabled: _propTypes2.default.bool,
  required: _propTypes2.default.bool
};
FormSelect.defaultProps = {
  enabled: true,
  filterValue: '',
  filterable: false,
  loading: false,
  onInputChanged: function onInputChanged() {},
  outsideClickToCloseEnabled: true,
  required: false
};
exports.default = FormSelect;